<?php
	/*
	 *
	 * 2003 - 2020 @ Yal Publicidad - YMS::intalacion
	 * www.yalpublicidad.com
	 * online@yalpublicidad.com
	 *
	 */
	 
	  /* Autorizo acceso */
		//defined( 'MSai' ) or die( '<h2>No dispones de acceso<h2>' );
		
	$msql['error'] = '';
	
	define( "YPATH", dirname( dirname( dirname(__FILE__) ) ) );
	
	$mysql_host	= ( isset( $_POST['mysql_host'] ) ) ? $_POST['mysql_host'] : 'localhost';
	$mysql_port = ( isset( $_POST['mysql_port'] ) && $_POST['mysql_port'] != NULL ) ? $_POST['mysql_port'] : 3306;
	$mysql_user = ( isset( $_POST['mysql_user'] ) ) ? $_POST['mysql_user'] : 'root';
	$mysql_pass	= ( isset( $_POST['mysql_pass'] ) ) ? $_POST['mysql_pass'] : 1234;
	$mysql_db	= ( isset( $_POST['mysql_db'] ) ) ? $_POST['mysql_db'] : NULL;
	$mysql_prefijo= ( isset( $_POST['mysql_prefijo'] ) ) ? $_POST['mysql_prefijo'] : 'wy_';

	$user		= ( isset( $_POST['user'] ) ) ? $_POST['user'] : NULL;
	$pass		= ( isset( $_POST['pass'] ) ) ? $_POST['pass'] : NULL;
	$email		= ( isset( $_POST['email'] ) ) ? $_POST['email'] : NULL;
	$utf		= ( isset( $_POST['charset'] ) ) ? $_POST['charset'] : 'utf-8';
	$lng		= ( isset( $_POST['lng'] ) ) ? $_POST['lng'] : 'es';
	$gmt_id		= ( isset( $_POST['gmt_id'] ) ) ? $_POST['gmt_id'] : 10;
	$gmt		= ( isset( $_POST['gmt'] ) ) ? $_POST['gmt'] : -5;
	$title		= ( isset( $_POST['title'] ) ) ? $_POST['title'] : NULL;
	$descripcion= ( isset( $_POST['descripcion'] ) ) ? $_POST['descripcion'] : NULL;
	$keywords	= ( isset( $_POST['keywords'] ) ) ? $_POST['keywords'] : NULL;
	$organizacion= ( isset( $_POST['organizacion'] ) ) ? $_POST['organizacion'] : NULL;
	
	
	
	define( "TBLPREFIJO", $mysql_prefijo );
		
		set_error_handler( function()
		{
			throw new Exception("Falló conexión con MySQL.");
		});
		
	
	/* Encriptar cadena 
		 * ej. FNX_Encriptar('mi_cadena', 'mi_llave', 'Encriptar');
		 * ej. FNX_Encriptar('mi_cadena', 'mi_llave', 'Desencriptar');
		 */
	function encriptar($string, $key, $acc = 'Encriptar') {
			$result = '';
			$retorno = '/%?==';
			
			$acc	= strtolower( $acc );
			
			if($acc=='encriptar'){
				for($i=0; $i<strlen($string); $i++) {
					$char = substr($string, $i, 1);
					$keychar = substr($key, ($i % strlen($key))-1, 1);
					$char = chr(ord($char)+ord($keychar));
					$result.=$char;
				}
				$retorno = base64_encode($result);
			}
			
			if($acc=='desencriptar'){
				$string = base64_decode($string);
				for($i=0; $i<strlen($string); $i++) {
					$char = substr($string, $i, 1);
					$keychar = substr($key, ($i % strlen($key))-1, 1);
					$char = chr(ord($char)-ord($keychar));
					$result.=$char;
				}
				$retorno = $result;
			}
			
			return $retorno;
	}
		
	/*
	 * Importar archivos .sql
	 */
	function importar_sql( $nombre_del_archivo ){
		// comprueba si el archivo SLQ existe
		if ( !file_exists( $nombre_del_archivo ) ) return false;
		
		global $mysqli, $msql;
		
		//$mysqli->query( WYSQL::$SQLConn, $consulta );
		
		// Variable temporal, utilizada para almacenar la consulta actual
		$templinea = '';
		// Leer en archivo completo
		$lineas = file( $nombre_del_archivo );
		// Bucle a través de cada línea
		foreach ($lineas as $linea)
		{
			// Omitirlo si es un comentario
			if (substr($linea, 0, 2) == '--' || $linea == '')
				continue;
			
			// Añadir esta línea al segmento actual
			$templinea .= str_replace( '<WYDBPREFIJO>', TBLPREFIJO, $linea );
			// Si tiene un punto y coma al final, es el final de la consulta
			if (substr(trim($linea), -1, 1) == ';')
			{
				// Realizar la consulta: $msql['error'] = 'Error al relizar la consulta \'<strong>' . $templinea . '\': ' . $mysqli->error
				$mysqli->query($templinea) or print( $mysqli->error );
				// Restablecer variable temporal a vacío
				$templinea = '';
			}
		}
		
		return true;
	}
	
	// ** Guardar fichero
	function gfichero( $ruta, $contenido = '' ){
		
		if ( !empty( $ruta ) )
		{
			$file = fopen( $ruta , 'w' );
			fwrite($file, $contenido  . PHP_EOL);
			fclose($file);
			return $contenido;
		}
		return false;
	}
	
	// ** obtener base sitio Weby+
	function base_sitioWeby(){
			$base = rtrim( dirname( dirname( dirname($_SERVER['SCRIPT_NAME'] ) ) ), '/\\' );
			$base = $base . '/';
			return $base;
	}
	
	// ** Generar fichero .htaccess
	function htaccess( $base ){
		return '########## COMIENZA WEBY+' . "\n" .
				   '# * 2003 - ' . date('Y') . ' @ Yal Publicidad - Webyplus' . "\n" .
				   '# * www.yalpublicidad.com' . "\n" .
				   '# * online@yalpublicidad.com' . "\n" . "\n" .
				   '# Establecer DirectoryIndex' . "\n" .
				   '	DirectoryIndex index.php' . "\n" . "\n" .
				   '# Impedir listar el directorio' . "\n" .
				   '	Options -Indexes'  . "\n" .
				   '	order deny,allow' . "\n" . "\n" .
				   '# Ocultando htaccess|htpasswd' . "\n" .
				   '<Files ~ "^\.(htaccess|htpasswd)$">' . "\n" .
				   '	deny from all' . "\n" .
				   '</Files>' . "\n" . "\n" .
				   '<FilesMatch "^.*(error_log|wy_.*|y_.*|php.ini|\.[hH][tT][aApP][y].*)$">' . "\n" .
				   '	Order deny,allow' . "\n" .
				   '	Deny from all' . "\n" .
				   '</FilesMatch>' . "\n" . "\n" .
				   '<IfModule mod_rewrite.c>' . "\n" .
				   '	RewriteEngine On' . "\n" .
				   '	RewriteBase ' . $base . "\n" .
				   '	RewriteRule ^index\.php$ - [L]' . "\n" .
				   '	RewriteCond %{REQUEST_FILENAME} !-f' . "\n" .
				   '	RewriteCond %{REQUEST_FILENAME} !-d' . "\n" .
				   '	RewriteRule . ' . $base . 'index.php [L]' . "\n" .
				   '</IfModule>' . "\n" . "\n" .
				   '# Reescribir ErrorDocument'. "\n" .
				   '	ErrorDocument 403 /error/HTTP_ErrorDocument.php?var=403' . "\n" .
				   '	ErrorDocument 404 /error/HTTP_ErrorDocument.php?var=404' . "\n" .
				   '	ErrorDocument 500 /error/HTTP_ErrorDocument.php?var=500' . "\n" .
				   '########## FINALIZA WEBY';
	}
	
	$iWeby	= false;
	$iYGE	= false;
	$cUser	= false;
	
	// verifico datos de conexion a MySQL
		try{
			// conecto con db
				$mysqli = new mysqli( $mysql_host, $mysql_user, $mysql_pass, $mysql_db, $mysql_port );
				
			// crear tablas WebyPlus
				if( importar_sql( 'wydb.sql' ) ) {
					$iWeby = true;
					// crear tablas YGE
					if( $mysqli->query( "SHOW TABLES LIKE 'ygepaisesiprango'" ) === true ) {
						$iYGE = true;
					}else{
						if( importar_sql( 'ygedb.sql' ) )  $iYGE = true;
					}
				}
				
			// crear cuenta de usuario
				if( $mysqli->query( "SHOW TABLES LIKE '" . TBLPREFIJO . "usuarios'" ) ) {
					if( $mysqli->query( "INSERT INTO `" . TBLPREFIJO . "usuarios`(`nivel`, `usuario`, `password`, `nombre_usuario`, `email`, `registrado`, `tokens`, `bloqueado`) VALUES ('Administrador', '$user', '" . md5( encriptar( $pass, strtolower($user) ) ) . "', '$user', '$email', '" . date( 'Y-m-d H:i:s' ) . "', '==', '1')" ) or print( $mysqli->error ) ) {
						$cUser = true;
								//"nivel":"Administrador","lenguaje":"es","utc_id":"10","utc":"-5"
					}
				}
			
			// crear fichero cuentas_usuarios
				$jsonCU = '{"'. $user . '":{"nivel":"Administrador","lenguaje":"' . $lng . '","utc_id":"' . $gmt_id . '","utc":"' . $gmt . '"}}';
				gfichero( YPATH . '/ypanel/.ypanel/datos/cuentas_usuarios', $jsonCU );
			// Configuración .htaccess:
				gfichero( YPATH . "/.htaccess", htaccess( base_sitioWeby() ) );
				
				
				
				if( $iWeby && $iYGE && $cUser ){
					echo 1;
				}else{
					echo $mysqli->error;
				}
		}catch( Throwable $t ){
				echo $t->getMessage() . PHP_EOL;
			//Restablecemos el tratamiento de errores
				restore_error_handler();
		}
	
	
?>